Overview | Package | Class | Tree | Deprecated | Index | Help | Weka's home
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## weka.classifiers.bayes.net
Class ADNode

    java.lang.Object
      weka.classifiers.bayes.net.ADNode

All Implemented Interfaces:
  java.io.Serializable

    public class ADNode

extends java.lang.Object
implements java.io.Serializable

The ADNode class implements the ADTree datastructure which increases the speed with which sub-contingency tables can be constructed from a data set in an Instances object. For details, see Cached Sufficient Statistics for Efficient Machine Learning with Large Datasets Andrew Moore, and Mary Soon Lee Journal of Artificial Intelligence Research 8 (1998) 67-91

Version:
  $Revision: 1.3 $
Author:
  Remco Bouckaert (rrb@xm.co.nz)
See Also:
  Serialized Form

Field Summary
`Instance[]` | `m_Instances` list of Instance children (either m_Instances or m_VaryNodes is instantiated)
`int` | `m_nCount` count
`int` | `m_nStartNode` first node in VaryNode array
`VaryNode[]` | `m_VaryNodes` list of VaryNode children

Constructor Summary
`ADNode()` Creates new ADNode

Method Summary
`void` | `getCounts(int[] nCounts, int[] nNodes, int[] nOffsets, int iNode, int iOffset, boolean bSubstract)` get counts for specific instantiation of a set of nodes
`static void` | `main(java.lang.String[] argv)`
`static ADNode` | `makeADTree(Instances instances)` create AD tree from set of instances
`static ADNode` | `makeADTree(int iNode, FastVector nRecords, Instances instances)` create sub tree
`static VaryNode` | `makeVaryNode(int iNode, FastVector nRecords, Instances instances)` create sub tree
`void` | `print()`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### m_VaryNodes

    public VaryNode[] m_VaryNodes

  list of VaryNode children

### m_Instances

    public Instance[] m_Instances

  list of Instance children (either m_Instances or m_VaryNodes is instantiated)

### m_nCount

    public int m_nCount

  count

### m_nStartNode

    public int m_nStartNode

  first node in VaryNode array

Constructor Detail

### ADNode

    public ADNode()

  Creates new ADNode

Method Detail

### makeVaryNode

    public static VaryNode makeVaryNode(int iNode,
                                        FastVector nRecords,
                                        Instances instances)

  create sub tree

  Parameters:
    `iNode:` - index of the lowest node in the tree
    `nRecords:` - set of records in instances to be considered
    `instances:` - data set
  Returns:
    VaryNode representing part of an ADTree

### makeADTree

    public static ADNode makeADTree(int iNode,
                                    FastVector nRecords,
                                    Instances instances)

  create sub tree

  Parameters:
    `iNode:` - index of the lowest node in the tree
    `nRecords:` - set of records in instances to be considered
    `instances:` - data set
  Returns:
    ADNode representing an ADTree

### makeADTree

    public static ADNode makeADTree(Instances instances)

  create AD tree from set of instances

  Parameters:
    `instances:` - data set
  Returns:
    ADNode representing an ADTree

### getCounts

    public void getCounts(int[] nCounts,
                          int[] nNodes,
                          int[] nOffsets,
                          int iNode,
                          int iOffset,
                          boolean bSubstract)

  get counts for specific instantiation of a set of nodes

  Parameters:
    `nCounts` - - array for storing counts
    `nNodes` - - array of node indexes
    `nOffsets` - - offset for nodes in nNodes in nCounts
    `iNode` - - index into nNode indicating current node
    `iOffset` - - Offset into nCounts due to nodes below iNode
    `bSubstract` - - indicate whether counts should be added or substracted

### print

    public void print()

### main

    public static void main(java.lang.String[] argv)

Overview | Package | Class | Tree | Deprecated | Index | Help | Weka's home
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD